/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package meetingroom.ui.reservasi;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.table.DefaultTableModel;
import meetingroom.ui.login.HomeScreen;
import meetingroom.util.MeetingHelper;
import meetingroom.util.MyConnection;

/**
 *
 * @author Legion
 */
public class PengajuanRuanganScreen extends javax.swing.JFrame {

    private final Connection connection = new MyConnection().connect();
    private DefaultTableModel tabmode;
    private SimpleDateFormat sdFormat = new SimpleDateFormat ("yyyy-MM-dd");
    /**
     * Creates new form PengajuanRuanganScreen
     */
    public PengajuanRuanganScreen() {
        initComponents();
        generateComboBoxRuangan();
        generateComboBoxPaket();
        generateComboBoxPeserta();
        setExtendedState(JFrame.MAXIMIZED_HORIZ);
    }

    String username;
    
    public String setUsername(String user) {
        System.out.println("PengajuanRuanganScreen : " + user);
        return this.username = user;
    }

    private void generateComboBoxRuangan() {
        try {
            Statement stat = connection.createStatement();
            String sql = "SELECT * FROM MASTER_RUANG ORDER BY NAMA_RUANG";
            ResultSet result = stat.executeQuery(sql);
            while (result.next()) {
                cmbRuangan.addItem(result.getString("id_ruang"));
            }
        } catch (SQLException e) {
            JOptionPane.showMessageDialog(this, e.getMessage());
        }
    }

    private void generateComboBoxPaket() {
        try {
            Statement stat = connection.createStatement();
            String sql = "SELECT * FROM MASTER_PAKET ORDER BY NAMA_PAKET";
            ResultSet result = stat.executeQuery(sql);
            while (result.next()) {
                cmbPaket.addItem(result.getString("id_paket"));
            }
        } catch (SQLException e) {
            JOptionPane.showMessageDialog(this, e.getMessage());
        }
    }

    private void generateComboBoxPeserta() {
        try {
            Statement stat = connection.createStatement();
            String sql = "SELECT * FROM USER ORDER BY NAME";
            ResultSet result = stat.executeQuery(sql);
            while (result.next()) {
                cmbPeserta.addItem(result.getString("username"));
            }

            Object[] Baris = {"Username", "Nama Peserta"};
            tabmode = new DefaultTableModel(null, Baris);
            tablePeserta.setModel(tabmode);
        } catch (SQLException e) {
            JOptionPane.showMessageDialog(this, e.getMessage());
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel2 = new javax.swing.JLabel();
        labelIdPaket = new javax.swing.JLabel();
        txtNoReservasi = new javax.swing.JTextField();
        labelAgenda = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        cmbRuangan = new javax.swing.JComboBox();
        labelJumlah = new javax.swing.JLabel();
        txtPeserta = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        labelTanggal = new javax.swing.JLabel();
        dtTglRapat = new com.toedter.calendar.JDateChooser();
        txtAgenda = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        cmbPaket = new javax.swing.JComboBox();
        jScrollPane1 = new javax.swing.JScrollPane();
        tablePeserta = new javax.swing.JTable();
        jLabel5 = new javax.swing.JLabel();
        cmbPeserta = new javax.swing.JComboBox();
        btnTambah = new javax.swing.JButton();
        btnDelete = new javax.swing.JButton();
        btnSimpan = new javax.swing.JButton();
        btnCancel = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setPreferredSize(new java.awt.Dimension(617, 514));

        jLabel2.setFont(new java.awt.Font("Segoe UI Light", 1, 24)); // NOI18N
        jLabel2.setText("Pengajuan Ruangan");

        labelIdPaket.setText("No Pengajuan");

        labelAgenda.setText("Agenda");

        jLabel1.setText("Ruangan");

        cmbRuangan.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "--Pilih Data--" }));

        labelJumlah.setText("Jumlah Peserta");

        jLabel4.setText("Orang");

        labelTanggal.setText("Tanggal Rapat");

        dtTglRapat.setDateFormatString("yyyy-MM-dd");

        jLabel3.setText("Paket");

        cmbPaket.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "--Pilih Data--" }));

        tablePeserta.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null}
            },
            new String [] {
                "Username", "Nama"
            }
        ));
        jScrollPane1.setViewportView(tablePeserta);

        jLabel5.setText("Daftar Peserta");

        cmbPeserta.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "--Pilih Data--" }));

        btnTambah.setText("Tambah");
        btnTambah.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnTambahActionPerformed(evt);
            }
        });

        btnDelete.setText("Hapus");
        btnDelete.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnDeleteActionPerformed(evt);
            }
        });

        btnSimpan.setText("Simpan");
        btnSimpan.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSimpanActionPerformed(evt);
            }
        });

        btnCancel.setText("Batal");
        btnCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCancelActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jLabel2)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                .addComponent(jLabel3, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(labelTanggal, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(labelJumlah, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(labelIdPaket, javax.swing.GroupLayout.DEFAULT_SIZE, 83, Short.MAX_VALUE)
                                    .addComponent(labelAgenda, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, 105, Short.MAX_VALUE)))
                            .addComponent(jLabel5))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(txtNoReservasi, javax.swing.GroupLayout.PREFERRED_SIZE, 237, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(txtPeserta, javax.swing.GroupLayout.PREFERRED_SIZE, 74, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel4, javax.swing.GroupLayout.PREFERRED_SIZE, 48, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(dtTglRapat, javax.swing.GroupLayout.PREFERRED_SIZE, 137, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                    .addComponent(cmbPeserta, javax.swing.GroupLayout.Alignment.LEADING, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(cmbPaket, javax.swing.GroupLayout.Alignment.LEADING, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(cmbRuangan, javax.swing.GroupLayout.Alignment.LEADING, 0, 238, Short.MAX_VALUE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(btnTambah)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(btnDelete))
                            .addComponent(txtAgenda)))
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 535, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(btnSimpan)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnCancel)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {jLabel1, labelAgenda, labelIdPaket, labelJumlah});

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {btnDelete, btnTambah});

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {btnCancel, btnSimpan});

        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel2)
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(txtNoReservasi)
                    .addComponent(labelIdPaket, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labelAgenda)
                    .addComponent(txtAgenda, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(cmbRuangan, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labelJumlah)
                    .addComponent(txtPeserta, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel4))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(labelTanggal)
                    .addComponent(dtTglRapat, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(cmbPaket, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(22, 22, 22)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel5)
                    .addComponent(cmbPeserta, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(btnTambah)
                    .addComponent(btnDelete))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 160, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btnSimpan)
                    .addComponent(btnCancel))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        layout.linkSize(javax.swing.SwingConstants.VERTICAL, new java.awt.Component[] {jLabel1, labelAgenda, labelIdPaket, labelJumlah});

        setBounds(700, 300, 651, 561);
    }// </editor-fold>//GEN-END:initComponents

    private void btnTambahActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnTambahActionPerformed
        dataTable(cmbPeserta.getSelectedItem().toString());
    }//GEN-LAST:event_btnTambahActionPerformed

    private void btnDeleteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnDeleteActionPerformed
        tabmode.removeRow(0);
    }//GEN-LAST:event_btnDeleteActionPerformed

    private void btnCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCancelActionPerformed
        doReset();
        new HomeScreen().setVisible(true);
        this.setVisible(false);
    }//GEN-LAST:event_btnCancelActionPerformed

    private void doReset() {
        txtNoReservasi.setText("");
        txtAgenda.setText("");
        cmbRuangan.setSelectedIndex(0);
        txtPeserta.setText("");
        dtTglRapat.setDate(null);
        cmbPaket.setSelectedIndex(0);
        cmbPeserta.setSelectedIndex(0);
        tabmode.setRowCount(0);
    }
    
    public boolean doValidate() {
        boolean valid = false;
        if (MeetingHelper.validateTextRequired(txtNoReservasi)
                && MeetingHelper.validateTextRequired(txtAgenda)
                && MeetingHelper.validateCalendarRequired(dtTglRapat)
                && MeetingHelper.validateComboboxRequired(cmbRuangan)
                && MeetingHelper.validateComboboxRequired(cmbPaket)
                && MeetingHelper.validateTextRequired(txtPeserta)) {
            valid = true;
        }

        return valid;
    }

    private void btnSimpanActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSimpanActionPerformed
        if (!doValidate()) {
            return;
        }
        try {
            String sql = "INSERT INTO RESERVASI (ID_RESERVASI, NO_RESERVASI, AGENDA, RESERVASI_DATE, ID_RUANG, PESERTA, REQUEST_BY, REQUEST_DATE, STATUS ) "
                    + " VALUES (?,?,?,?,?,?,?,?,?)";
            PreparedStatement stat = connection.prepareStatement(sql);
            String idReservasi = String.valueOf(System.currentTimeMillis());
            stat.setString(1, idReservasi);
            stat.setString(2, txtNoReservasi.getText());
            stat.setString(3, txtAgenda.getText());
            stat.setString(4, sdFormat.format (dtTglRapat.getDate()));
            stat.setString(5, cmbRuangan.getSelectedItem().toString());
            stat.setString(6, txtPeserta.getText());
            stat.setString(7, "lukmanarizal@gmail.com");
            stat.setTimestamp(8, java.sql.Timestamp.valueOf(java.time.LocalDateTime.now()));
            stat.setString(9, "2");
            stat.executeUpdate();
            
            String sqlPaket = "INSERT INTO RESERVASI_PAKET VALUES (?,?)";
            PreparedStatement statPaket = connection.prepareStatement(sqlPaket);
            statPaket.setString(1, idReservasi);
            statPaket.setString(2, cmbPaket.getSelectedItem().toString());
            statPaket.executeUpdate();
            
            for (int row = 0; row < tablePeserta.getRowCount(); row++){
                DefaultTableModel model = (DefaultTableModel) tablePeserta.getModel();
                String userSelected = model.getValueAt(row, 0).toString();

                String sqlPeserta = "INSERT INTO RESERVASI_PESERTA VALUES (?,?)";
                PreparedStatement statPeserta = connection.prepareStatement(sqlPeserta);
                statPeserta.setString(1, idReservasi);
                statPeserta.setString(2, userSelected);
                statPeserta.executeUpdate();
            }

            JOptionPane.showMessageDialog(null, "Data Berhasil Disimpan");
            doReset();
        } catch (SQLException e) {
            JOptionPane.showMessageDialog(null, "Data Gagal Disimpan" + e.getMessage());
        }
    }//GEN-LAST:event_btnSimpanActionPerformed

    private void dataTable(String username) {
        try {
            Statement stat = connection.createStatement();
            String sql = "SELECT * FROM USER WHERE USERNAME = '" + username + "'";
            ResultSet result = stat.executeQuery(sql);
            if (result.next()) {
                String a = result.getString("username");
                String b = result.getString("name");
                String[] data = {a, b};
                tabmode.addRow(data);
            }

        } catch (SQLException e) {
            JOptionPane.showMessageDialog(this, e.getMessage());
        }
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(PengajuanRuanganScreen.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(PengajuanRuanganScreen.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(PengajuanRuanganScreen.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(PengajuanRuanganScreen.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new PengajuanRuanganScreen().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnCancel;
    private javax.swing.JButton btnDelete;
    private javax.swing.JButton btnSimpan;
    private javax.swing.JButton btnTambah;
    private javax.swing.JComboBox cmbPaket;
    private javax.swing.JComboBox cmbPeserta;
    private javax.swing.JComboBox cmbRuangan;
    private com.toedter.calendar.JDateChooser dtTglRapat;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JLabel labelAgenda;
    private javax.swing.JLabel labelIdPaket;
    private javax.swing.JLabel labelJumlah;
    private javax.swing.JLabel labelTanggal;
    private javax.swing.JTable tablePeserta;
    private javax.swing.JTextField txtAgenda;
    private javax.swing.JTextField txtNoReservasi;
    private javax.swing.JTextField txtPeserta;
    // End of variables declaration//GEN-END:variables

}
